# -*- coding: utf-8 -*-


class ActorDamageCause(object):
	NONE                = "none"               # 其他
	Override            = "override"           # 非正常方式（如脚本直接设置血量为0）
	Contact             = "contact"            # 接触伤害（如仙人掌）
	EntityAttack        = "entity_attack"      # 生物攻击
	Projectile          = "projectile"         # 抛射物攻击
	Suffocation         = "suffocation"        # 窒息（密封空间）
	Fall                = "fall"               # 掉落
	Fire                = "fire"               # 着火
	FireTick            = "fire_tick"          # 连续着火（生物着火、在火中）
	Lava                = "lava"               # 熔岩
	Drowning            = "drowning"           # 溺水
	BlockExplosion      = "block_explosion"    # 方块爆炸
	EntityExplosion     = "entity_explosion"   # 生物爆炸
	Void                = "void"               # 虚空
	Suicide             = "suicide"            # 自杀（kill命令）
	Magic               = "magic"              # 尖牙对生物造成的伤害、守卫者对生物造成的魔法伤害和药水伤害等
	Wither              = "wither"             # 凋零 poison
	Starve              = "starve"             # 饥饿
	Anvil               = "anvil"              # 下落的铁砧
	Thorns              = "thorns"             # 荆棘反弹伤害
	FallingBlock        = "falling_block"      # 下落的方块（除了铁砧）
	Piston              = "piston"             # 活塞
	FlyIntoWall         = "fly_into_wall"      # 滑翔（撞墙）
	Magma               = "magma"              # 岩浆（如站在岩浆方块上）
	Fireworks           = "fireworks"          # 烟花
	Lightning           = "lightning"          # 闪电

class ArmorSlotType(object):
	DEFAULT = -1
	HEAD = 0
	BODY = 1
	LEG = 2
	FOOT = 3

class AttrType(object):
	HEALTH = 0
	SPEED = 1
	DAMAGE = 2
	UNDERWATER_SPEED = 3
	HUNGER = 4
	SATURATION = 5
	ABSORPTION = 6
	LAVA_SPEED = 7

class AttributeBuffType(object):
	Hunger = 0
	Saturation = 1
	Regeneration = 2
	Heal = 3
	Harm = 4
	Magic = 5
	Wither = 6
	Poison = 7
	FatalPoison = 8
	SelfHeal = 9

class BiomeType:
	ocean = 0
	plains = 1
	desert = 2
	extreme_hills = 3
	forest = 4
	taiga = 5
	swampland = 6
	river = 7
	hell = 8
	the_end = 9
	legacy_frozen_ocean = 10
	frozen_river = 11
	ice_plains = 12
	ice_mountains = 13
	mushroom_island = 14
	mushroom_island_shore = 15
	beach = 16
	desert_hills = 17
	forest_hills = 18
	taiga_hills = 19
	extreme_hills_edge = 20
	jungle = 21
	jungle_hills = 22
	jungle_edge = 23
	deep_ocean = 24
	stone_beach = 25
	cold_beach = 26
	birch_forest = 27
	birch_forest_hills = 28
	roofed_forest = 29
	cold_taiga = 30
	cold_taiga_hills = 31
	mega_taiga = 32
	mega_taiga_hills = 33
	extreme_hills_plus_trees = 34
	savanna = 35
	savanna_plateau = 36
	mesa = 37
	mesa_plateau_stone = 38
	mesa_plateau = 39
	warm_ocean = 40
	deep_warm_ocean = 41
	lukewarm_ocean = 42
	deep_lukewarm_ocean = 43
	cold_ocean = 44
	deep_cold_ocean = 45
	frozen_ocean = 46
	deep_frozen_ocean = 47
	bamboo_jungle = 48
	bamboo_jungle_hills = 49
	sunflower_plains = 129
	desert_mutated = 130
	extreme_hills_mutated = 131
	flower_forest = 132
	taiga_mutated = 133
	swampland_mutated = 134
	ice_plains_spikes = 140
	jungle_mutated = 149
	jungle_edge_mutated = 151
	birch_forest_mutated = 155
	birch_forest_hills_mutated = 156
	roofed_forest_mutated = 157
	cold_taiga_mutated = 158
	redwood_taiga_mutated = 160
	redwood_taiga_hills_mutated = 161
	extreme_hills_plus_trees_mutated = 162
	savanna_mutated = 163
	savanna_plateau_mutated = 164
	mesa_bryce = 165
	mesa_plateau_stone_mutated = 166
	mesa_plateau_mutated = 167
	soulsand_valley = 178
	crimson_forest = 179
	warped_forest = 180
	basalt_deltas = 181

class BlockType:
	air = 0
	stone = 1
	grass = 2
	dirt = 3
	cobblestone = 4
	planks = 5
	sapling = 6
	bedrock = 7
	flowing_water = 8
	water = 9
	flowing_lava = 10
	lava = 11
	sand = 12
	gravel = 13
	gold_ore = 14
	iron_ore = 15
	coal_ore = 16
	log = 17
	leaves = 18
	sponge = 19
	glass = 20
	lapis_ore = 21
	lapis_block = 22
	dispenser = 23
	sandstone = 24
	noteblock = 25
	bed = 26
	golden_rail = 27
	detector_rail = 28
	sticky_piston = 29
	web = 30
	tallgrass = 31
	deadbush = 32
	piston = 33
	pistonArmCollision = 34
	wool = 35
	yellow_flower = 37
	red_flower = 38
	brown_mushroom = 39
	red_mushroom = 40
	gold_block = 41
	iron_block = 42
	stone_slab = 44
	double_stone_slab = 43
	brick_block = 45
	tnt = 46
	bookshelf = 47
	mossy_cobblestone = 48
	obsidian = 49
	torch = 50
	mob_spawner = 52
	oak_stairs = 53
	chest = 54
	redstone_wire = 55
	diamond_ore = 56
	diamond_block = 57
	crafting_table = 58
	wheat = 59
	farmland = 60
	furnace = 61
	lit_furnace = 62
	standing_sign = 63
	wooden_door = 64
	ladder = 65
	rail = 66
	stone_stairs = 67
	wall_sign = 68
	lever = 69
	stone_pressure_plate = 70
	iron_door = 71
	wooden_pressure_plate = 72
	redstone_ore = 73
	lit_redstone_ore = 74
	unlit_redstone_torch = 75
	redstone_torch = 76
	stone_button = 77
	snow_layer = 78
	ice = 79
	snow = 80
	cactus = 81
	clay = 82
	reeds = 83
	jukebox = 84
	fence = 85
	pumpkin = 86
	netherrack = 87
	soul_sand = 88
	glowstone = 89
	portal = 90
	lit_pumpkin = 91
	cake = 92
	unpowered_repeater = 93
	powered_repeater = 94
	invisibleBedrock = 95
	trapdoor = 96
	monster_egg = 97
	stonebrick = 98
	brown_mushroom_block = 99
	red_mushroom_block = 100
	iron_bars = 101
	glass_pane = 102
	melon_block = 103
	pumpkin_stem = 104
	melon_stem = 105
	vine = 106
	fence_gate = 107
	brick_stairs = 108
	stone_brick_stairs = 109
	mycelium = 110
	waterlily = 111
	nether_brick = 112
	nether_brick_fence = 113
	nether_brick_stairs = 114
	nether_wart = 115
	enchanting_table = 116
	brewing_stand = 117
	cauldron = 118
	end_portal = 119
	end_portal_frame = 120
	end_stone = 121
	dragon_egg = 122
	redstone_lamp = 123
	lit_redstone_lamp = 124
	dropper = 125
	activator_rail = 126
	cocoa = 127
	sandstone_stairs = 128
	emerald_ore = 129
	ender_chest = 130
	tripwire_hook = 131
	tripWire = 132
	emerald_block = 133
	spruce_stairs = 134
	birch_stairs = 135
	jungle_stairs = 136
	command_block = 137
	beacon = 138
	cobblestone_wall = 139
	flower_pot = 140
	carrots = 141
	potatoes = 142
	wooden_button = 143
	skull = 144
	anvil = 145
	trapped_chest = 146
	light_weighted_pressure_plate = 147
	heavy_weighted_pressure_plate = 148
	unpowered_comparator = 149
	powered_comparator = 150
	daylight_detector = 151
	redstone_block = 152
	quartz_ore = 153
	hopper = 154
	quartz_block = 155
	quartz_stairs = 156
	wooden_slab = 158
	double_wooden_slab = 157
	stained_hardened_clay = 159
	stained_glass_pane = 160
	leaves2 = 161
	log2 = 162
	acacia_stairs = 163
	dark_oak_stairs = 164
	slime = 165
	iron_trapdoor = 167
	prismarine = 168
	seaLantern = 169
	hay_block = 170
	carpet = 171
	hardened_clay = 172
	coal_block = 173
	packed_ice = 174
	double_plant = 175
	standing_banner = 176
	wall_banner = 177
	daylight_detector_inverted = 178
	red_sandstone = 179
	red_sandstone_stairs = 180
	stone_slab2 = 182
	double_stone_slab2 = 181
	spruce_fence_gate = 183
	birch_fence_gate = 184
	jungle_fence_gate = 185
	dark_oak_fence_gate = 186
	acacia_fence_gate = 187
	repeating_command_block = 188
	chain_command_block = 189
	spruce_door = 193
	birch_door = 194
	jungle_door = 195
	acacia_door = 196
	dark_oak_door = 197
	grass_path = 198
	frame = 199
	chorus_flower = 200
	purpur_block = 201
	purpur_stairs = 203
	undyed_shulker_box = 205
	end_bricks = 206
	frosted_ice = 207
	end_rod = 208
	end_gateway = 209
	allow = 210
	deny = 211
	border_block = 212
	magma = 213
	nether_wart_block = 214
	red_nether_brick = 215
	bone_block = 216
	structure_void = 217
	shulker_box = 218
	purple_glazed_terracotta = 219
	white_glazed_terracotta = 220
	orange_glazed_terracotta = 221
	magenta_glazed_terracotta = 222
	light_blue_glazed_terracotta = 223
	yellow_glazed_terracotta = 224
	lime_glazed_terracotta = 225
	pink_glazed_terracotta = 226
	gray_glazed_terracotta = 227
	silver_glazed_terracotta = 228
	cyan_glazed_terracotta = 229
	blue_glazed_terracotta = 231
	brown_glazed_terracotta = 232
	green_glazed_terracotta = 233
	red_glazed_terracotta = 234
	black_glazed_terracotta = 235
	concrete = 236
	concretePowder = 237
	chorus_plant = 240
	stained_glass = 241
	camera = 242
	podzol = 243
	beetroot = 244
	stonecutter = 245
	stonecutter_block = 452
	glowingobsidian = 246
	netherreactor = 247
	info_update = 248
	info_update2 = 249
	movingBlock = 250
	observer = 251
	structure_block = 252
	reserved6 = 255
	prismarine_stairs = 257
	dark_prismarine_stairs = 258
	prismarine_bricks_stairs = 259
	stripped_spruce_log = 260
	stripped_birch_log = 261
	stripped_jungle_log = 262
	stripped_acacia_log = 263
	stripped_dark_oak_log = 264
	stripped_oak_log = 265
	blue_ice = 266
	fire = 51
	chemistry_table = 238
	underwater_torch = 239
	hard_glass = 253
	hard_stained_glass = 254
	hard_glass_pane = 190
	hard_stained_glass_pane = 191
	chemical_heat = 192
	colored_torch_rg = 202
	colored_torch_bp = 204
	mod_ore = 230
	element_0 = 36
	coral = 386
	coral_block = 387
	coral_fan = 388
	coral_fan_dead = 389
	coral_fan_hang = 390
	coral_fan_hang2 = 391
	coral_fan_hang3 = 392
	kelp = 393
	dried_kelp_block = 394
	seagrass = 385
	acacia_button = 395
	birch_button = 396
	dark_oak_button = 397
	jungle_button = 398
	spruce_button = 399
	acacia_trapdoor = 400
	birch_trapdoor = 401
	dark_oak_trapdoor = 402
	jungle_trapdoor = 403
	spruce_trapdoor = 404
	acacia_pressure_plate = 405
	birch_pressure_plate = 406
	dark_oak_pressure_plate = 407
	jungle_pressure_plate = 408
	spruce_pressure_plate = 409
	carved_pumpkin = 410
	sea_pickle = 411
	conduit = 412
	bubble_column = 415
	turtle_egg = 414
	barrier = 416
	scaffolding = 420
	bamboo = 418
	bamboo_sapling = 419
	stone_slab3 = 417
	stone_slab4 = 421
	double_stone_slab3 = 422
	double_stone_slab4 = 423
	granite_stairs = 424
	diorite_stairs = 425
	andesite_stairs = 426
	polished_granite_stairs = 427
	polished_diorite_stairs = 428
	polished_andesite_stairs = 429
	mossy_stone_brick_stairs = 430
	smooth_red_sandstone_stairs = 431
	smooth_sandstone_stairs = 432
	end_brick_stairs = 433
	mossy_cobblestone_stairs = 434
	normal_stone_stairs = 435
	smooth_stone = 438
	red_nether_brick_stairs = 439
	smooth_quartz_stairs = 440
	spruce_standing_sign = 436
	spruce_wall_sign = 437
	birch_standing_sign = 441
	birch_wall_sign = 442
	jungle_standing_sign = 443
	jungle_wall_sign = 444
	acacia_standing_sign = 445
	acacia_wall_sign = 446
	darkoak_standing_sign = 447
	darkoak_wall_sign = 448
	lectern = 449
	grindstone = 450
	blast_furnace = 451
	smoker = 453
	lit_smoker = 454
	cartography_table = 455
	fletching_table = 456
	smithing_table = 457
	barrel = 458
	loom = 459
	bell = 461
	sweet_berry_bush = 462
	lantern = 463
	campfire = 464
	lava_cauldron = 465
	jigsaw = 466
	wood = 467
	composter = 468
	lit_blast_furnace = 469
	light_block = 470
	wither_rose = 471
	stickyPistonArmCollision = 472
	bee_nest = 473
	beehive = 474
	honey_block = 475
	honeycomb_block = 476
	lodestone = 477
	crimson_roots = 478
	warped_roots = 479
	crimson_stem = 480
	warped_stem = 481
	warped_wart_block = 482
	crimson_fungus = 483
	warped_fungus = 484
	shroomlight = 485
	weeping_vines = 486
	crimson_nylium = 487
	warped_nylium = 488
	basalt = 489
	polished_basalt = 490
	soul_soil = 491
	soul_fire = 492
	nether_sprouts = 493
	target = 494
	stripped_crimson_stem = 495
	stripped_warped_stem = 496
	crimson_planks = 497
	warped_planks = 498
	crimson_door = 499
	warped_door = 500
	crimson_trapdoor = 501
	warped_trapdoor = 502
	crimson_standing_sign = 505
	warped_standing_sign = 506
	crimson_wall_sign = 507
	warped_wall_sign = 508
	crimson_stairs = 509
	warped_stairs = 510
	crimson_fence = 511
	warped_fence = 512
	crimson_fence_gate = 513
	warped_fence_gate = 514
	crimson_button = 515
	warped_button = 516
	crimson_pressure_plate = 517
	warped_pressure_plate = 518
	crimson_slab = 519
	warped_slab = 520
	crimson_double_slab = 521
	warped_double_slab = 522
	soul_torch = 523
	soul_lantern = 524
	netherite_block = 525
	ancient_debris = 526
	respawn_anchor = 527
	blackstone = 528
	polished_blackstone_bricks = 529
	polished_blackstone_brick_stairs = 530
	blackstone_stairs = 531
	blackstone_wall = 532
	polished_blackstone_brick_wall = 533
	chiseled_polished_blackstone = 534
	cracked_polished_blackstone_bricks = 535
	gilded_blackstone = 536
	blackstone_slab = 537
	blackstone_double_slab = 538
	polished_blackstone_brick_slab = 539
	polished_blackstone_brick_double_slab = 540
	chain = 541
	twisting_vines = 542
	nether_gold_ore = 543
	crying_obsidian = 544
	polished_blackstone = 546
	polished_blackstone_stairs = 547
	polished_blackstone_slab = 548
	polished_blackstone_double_slab = 549
	polished_blackstone_pressure_plate = 550
	polished_blackstone_button = 551
	polished_blackstone_wall = 552
	warped_hyphae = 553
	crimson_hyphae = 554
	stripped_crimson_hyphae = 555
	stripped_warped_hyphae = 556
	soul_campfire = 545
	chiseled_nether_bricks = 557
	cracked_nether_bricks = 558
	quartz_bricks = 559

class ButtonEventType(object):
	Clicked = 0
	Pressed = 1
	Released = 2

class ButtonState(object):
	Up = 0
	Down = 1

class Change:
	Add = 0
	Remove = 1

class ColorCode(object):
	BLACK = "\xc2\xa7" "0"          # 黑色
	DARK_BLUE = "\xc2\xa7" "1"      # 深蓝色
	DARK_GREEN = "\xc2\xa7" "2"     # 深绿色
	DARK_AQUA = "\xc2\xa7" "3"      # 湖蓝色
	DARK_RED = "\xc2\xa7" "4"       # 深红色
	DARK_PURPLE = "\xc2\xa7" "5"    # 紫色
	GOLD = "\xc2\xa7" "6"           # 金色
	GRAY = "\xc2\xa7" "7"           # 灰色
	DARK_GRAY = "\xc2\xa7" "8"      # 深灰色
	BLUE = "\xc2\xa7" "9"           # 蓝色
	GREEN = "\xc2\xa7" "a"          # 绿色
	AQUA = "\xc2\xa7" "b"           # 天蓝色
	RED = "\xc2\xa7" "c"            # 红色
	LIGHT_PURPLE = "\xc2\xa7" "d"   # 粉红色
	YELLOW = "\xc2\xa7" "e"         # 黄色
	WHITE = "\xc2\xa7" "f"          # 白色
	MINECOIN_GOLD = "\xc2\xa7" "g"  # 硬币金

	RAND = "\xc2\xa7" "k"           # 随机字符
	BOLD = "\xc2\xa7" "l"           # 粗体
	ITALIC = "\xc2\xa7" "o"         # 斜体
	RESET = "\xc2\xa7" "r"          # 重置文字样式

class EffectType:
	EMPTY_EFFECT = "empty"
	MOVEMENT_SPEED = "speed"
	MOVEMENT_SLOWDOWN = "slowness"
	DIG_SPEED = "haste"
	DIG_SLOWDOWN = "mining_fatigue"
	DAMAGE_BOOST = "strength"
	HEAL = "instant_health"
	HARM = "instant_damage"
	JUMP = "jump_boost"
	CONFUSION = "nausea"
	REGENERATION = "regeneration"
	DAMAGE_RESISTANCE = "resistance"
	FIRE_RESISTANCE = "fire_resistance"
	WATER_BREATHING = "water_breathing"
	INVISIBILITY = "invisibility"
	BLINDNESS = "blindness"
	NIGHT_VISION = "night_vision"
	HUNGER = "hunger"
	WEAKNESS = "weakness"
	POISON = "poison"
	WITHER = "wither"
	HEALTH_BOOST = "health_boost"
	ABSORPTION = "absorption"
	SATURATION = "saturation"
	LEVITATION = "levitation"
	FATAL_POISON = "fatal_poison"
	CONDUIT_POWER = "conduit_power"
	SLOW_FALLING = "slow_falling"
	BAD_OMEN = "bad_omen"
	HERO_OF_THE_VILLAGE = "village_hero"

class EnchantType:
	ArmorAll = 0
	ArmorFire = 1
	ArmorFall = 2
	ArmorExplosive = 3
	ArmorProjectile = 4
	ArmorThorns = 5
	WaterBreath = 6
	WaterSpeed = 7
	WaterAffinity = 8
	WeaponDamage = 9
	WeaponUndead = 10
	WeaponArthropod = 11
	WeaponKnockback = 12
	WeaponFire = 13
	WeaponLoot = 14
	MiningEfficiency = 15
	MiningSilkTouch = 16
	MiningDurability = 17
	MiningLoot = 18
	BowDamage = 19
	BowKnockback = 20
	BowFire = 21
	BowInfinity = 22
	FishingLoot = 23
	FishingLure = 24
	FrostWalker = 25
	Mending = 26
	CurseBinding = 27
	CurseVanishing = 28
	TridentImpaling = 29
	TridentRiptide = 30
	TridentLoyalty = 31
	TridentChanneling = 32
	CrossbowMultishot = 33
	CrossbowPiercing = 34
	CrossbowQuickCharge = 35
	SoulSpeed = 36
	NumEnchantments = 37
	InvalidEnchantment = 38

class EntityConst:
	TYPE_LVOBJ = "lvobj"
	TYPE_ENTITY = "entity"
	TYPE_MONSTER = "monster"
	TYPE_PLAYER = "player"
	TYPE_BULLET = "bullet"
	TYPE_SFX = "sfx"
	TYPE_BUFF = "buff"
	TYPE_PARTICLE = "particle"
	TYPE_EFFECT = "effect"
	TYPE_FONT = "font"
	TYPE_TEAM = "team"
	TYPE_ITEM_ENTITY = "item_entity"
	TYPE_NPC = "npc"
	TYPE_MOD_ENTITY = "mod_entity"

class EntityTeleportCause(object):
	Unkown = "0"		# 尚未具体分类，末影人自体传送目前归为此类
	Projectile = "1"	# 飞射物，类似末影珍珠
	Command = "3"		# op指令，类似传送指令
	ChorusFruit = "2"	# 吃紫颂果传送
	Behavior = "4"		# 微软原生脚本组件
	Agent = "agent"		# 教育版指导传送
	Client = "client"	# 客户端发送的传送移动包
	GateWay = "gateway"	# 传送门

class EntityType:
	Undefined = 1
	TypeMask = 0x000000ff
	Mob = 0x00000100
	PathfinderMob = 0x00000200 | Mob
	Monster = 0x00000800 | PathfinderMob
	Animal = 0x00001000 | PathfinderMob
	TamableAnimal = 0x00004000 | Animal
	Ambient = 0x00008000 | Mob
	UndeadMob = 0x00010000 | Monster
	ZombieMonster = 0x00020000 | UndeadMob
	Arthropod = 0x00040000 | Monster
	Minecart = 0x00080000
	SkeletonMonster = 0x00100000 | UndeadMob
	EquineAnimal = 0x00200000 | TamableAnimal
	Projectile = 0x00400000
	AbstractArrow = 0x00800000
	WaterAnimal = 0x00002000 | PathfinderMob
	VillagerBase = 0x01000000 | PathfinderMob
	Chicken = 10 | Animal
	Cow = 11 | Animal
	Pig = 12 | Animal
	Sheep = 13 | Animal
	Wolf = 14 | TamableAnimal
	Villager = 15 | VillagerBase
	MushroomCow = 16 | Animal
	Squid = 17 | WaterAnimal
	Rabbit = 18 | Animal
	Bat = 19 | Ambient
	IronGolem = 20 | PathfinderMob
	SnowGolem = 21 | PathfinderMob
	Ocelot = 22 | TamableAnimal
	Horse = 23 | EquineAnimal
	PolarBear = 28 | Animal
	Llama = 29 | Animal
	Parrot = 30 | TamableAnimal
	Dolphin = 31 | WaterAnimal
	Donkey = 24 | EquineAnimal
	Mule = 25 | EquineAnimal
	SkeletonHorse = 26 | EquineAnimal | UndeadMob
	ZombieHorse = 27 | EquineAnimal | UndeadMob
	Zombie = 32 | ZombieMonster
	Creeper = 33 | Monster
	Skeleton = 34 | SkeletonMonster
	Spider = 35 | Arthropod
	PigZombie = 36 | UndeadMob
	Slime = 37 | Monster
	EnderMan = 38 | Monster
	Silverfish = 39 | Arthropod
	CaveSpider = 40 | Arthropod
	Ghast = 41 | Monster
	LavaSlime = 42 | Monster
	Blaze = 43 | Monster
	ZombieVillager = 44 | ZombieMonster
	Witch = 45 | Monster
	Stray = 46 | SkeletonMonster
	Husk = 47 | ZombieMonster
	WitherSkeleton = 48 | SkeletonMonster
	Guardian = 49 | Monster
	ElderGuardian = 50 | Monster
	Npc = 51 | Mob
	WitherBoss = 52 | UndeadMob
	Dragon = 53 | Monster
	Shulker = 54 | Monster
	Endermite = 55 | Arthropod
	Agent = 56 | Mob
	Vindicator = 57 | Monster
	Phantom = 58 | UndeadMob
	IllagerBeast = 59 | Monster
	ArmorStand = 61 | Mob
	TripodCamera = 62 | Mob
	Player = 63 | Mob
	ItemEntity = 64
	PrimedTnt = 65
	FallingBlock = 66
	MovingBlock = 67
	ExperiencePotion = 68 | Projectile
	Experience = 69
	EyeOfEnder = 70
	EnderCrystal = 71
	FireworksRocket = 72
	Trident = 73 | Projectile | AbstractArrow
	Turtle = 74 | Animal
	Cat = 75 | TamableAnimal
	ShulkerBullet = 76 | Projectile
	FishingHook = 77
	Chalkboard = 78
	DragonFireball = 79 | Projectile
	Arrow = 80 | Projectile | AbstractArrow
	Snowball = 81 | Projectile
	ThrownEgg = 82 | Projectile
	Painting = 83
	LargeFireball = 85 | Projectile
	ThrownPotion = 86 | Projectile
	Enderpearl = 87 | Projectile
	LeashKnot = 88
	WitherSkull = 89 | Projectile
	BoatRideable = 90
	WitherSkullDangerous = 91 | Projectile
	LightningBolt = 93
	SmallFireball = 94 | Projectile
	AreaEffectCloud = 95
	LingeringPotion = 101 | Projectile
	LlamaSpit = 102 | Projectile
	EvocationFang = 103 | Projectile
	EvocationIllager = 104 | Monster
	Vex = 105 | Monster
	MinecartRideable = 84 | Minecart
	MinecartHopper = 96 | Minecart
	MinecartTNT = 97 | Minecart
	MinecartChest = 98 | Minecart
	MinecartFurnace = 99 | Minecart
	MinecartCommandBlock = 100 | Minecart
	IceBomb = 106 | Projectile
	Balloon = 107
	Pufferfish = 108 | WaterAnimal
	Salmon = 109 | WaterAnimal
	Drowned = 110 | ZombieMonster
	Tropicalfish = 111 | WaterAnimal
	Fish = 112 | WaterAnimal
	Panda = 113 | Animal
	Pillager = 114 | Monster
	VillagerV2 = 115 | VillagerBase
	ZombieVillagerV2 = 116 | ZombieMonster
	Shield = 117
	WanderingTrader = 118 | PathfinderMob
	Lectern = 119
	ElderGuardianGhost = 120 | Monster
	Fox = 121 | Animal
	Bee = 122 | Mob
	Piglin = 123 | Mob
	Hoglin = 124 | Animal
	Strider = 125 | Animal
	Zoglin = 126 | Mob
	# PiglinBrute = 127 | Mob     # 目前中国版为1.16.10，还不存在猪灵蛮兵
	CustomProjectile = 254 | Projectile
	EntityExtension = 255
	MAX_ENTITY_ID = 256

class Facing(object):
	Down = 0
	Up = 1
	North = 2
	South = 3
	West = 4
	East = 5

class GameDiffculty(object):
	Peaceful = 0
	Easy = 1
	Normal = 2
	Hard = 3
	Count = 4
	Unknown = 5

class GameType(object):
	Undefined = -1
	Survival = 0
	Creative = 1
	Adventure = 2
	Default = Survival

class ItemAcquisitionMethod(object):
	Unknown = -1
	MethodNone = 0
	PickedUp = 1
	Crafted = 2
	TakenFromChest = 3
	TakenFromEnderchest = 4
	Bought = 5
	Anvil = 6
	Smelted = 7
	Brewed = 8
	Filled = 9
	Trading = 10
	Fishing = 11
	Container = 13

class ItemColor(object):
	Black = 0
	Red = 1
	Green = 2
	Brown = 3
	Blue = 4
	Purple = 5
	Cyan = 6
	Silver = 7
	Gray = 8
	Pink = 9
	Lime = 10
	Yellow = 11
	LightBlue = 12
	Magenta = 13
	Orange = 14
	White = 15

class ItemPosType(object):
	INVENTORY = 0
	OFFHAND = 1
	CARRIED = 2
	ARMOR = 3

class ItemType:
	apple = 260
	golden_apple = 322
	appleEnchanted = 466
	mushroom_stew = 282
	bread = 297
	porkchop = 319
	cooked_porkchop = 320
	fish = 349
	salmon = 460
	clownfish = 461
	pufferfish = 462
	cooked_fish = 350
	cooked_salmon = 463
	dried_kelp = 464
	cookie = 357
	melon = 360
	beef = 363
	cooked_beef = 364
	chicken = 365
	cooked_chicken = 366
	rotten_flesh = 367
	spider_eye = 375
	carrot = 391
	potato = 392
	baked_potato = 393
	poisonous_potato = 394
	golden_carrot = 396
	pumpkin_pie = 400
	beetroot = 457
	beetroot_soup = 459
	sweet_berries = 477
	rabbit = 411
	cooked_rabbit = 412
	rabbit_stew = 413
	wheat_seeds = 295
	pumpkin_seeds = 361
	melon_seeds = 362
	nether_wart = 372
	beetroot_seeds = 458
	iron_shovel = 256
	iron_pickaxe = 257
	iron_axe = 258
	flint_and_steel = 259
	bow = 261
	arrow = 262
	coal = 263
	diamond = 264
	iron_ingot = 265
	gold_ingot = 266
	iron_sword = 267
	wooden_sword = 268
	wooden_shovel = 269
	wooden_pickaxe = 270
	wooden_axe = 271
	stone_sword = 272
	stone_shovel = 273
	stone_pickaxe = 274
	stone_axe = 275
	diamond_sword = 276
	diamond_shovel = 277
	diamond_pickaxe = 278
	diamond_axe = 279
	stick = 280
	bowl = 281
	golden_sword = 283
	golden_shovel = 284
	golden_pickaxe = 285
	golden_axe = 286
	string = 287
	feather = 288
	gunpowder = 289
	wooden_hoe = 290
	stone_hoe = 291
	iron_hoe = 292
	diamond_hoe = 293
	golden_hoe = 294
	wheat = 296
	leather_helmet = 298
	leather_chestplate = 299
	leather_leggings = 300
	leather_boots = 301
	chainmail_helmet = 302
	chainmail_chestplate = 303
	chainmail_leggings = 304
	chainmail_boots = 305
	iron_helmet = 306
	iron_chestplate = 307
	iron_leggings = 308
	iron_boots = 309
	diamond_helmet = 310
	diamond_chestplate = 311
	diamond_leggings = 312
	diamond_boots = 313
	mod_armor = 454
	golden_helmet = 314
	golden_chestplate = 315
	golden_leggings = 316
	golden_boots = 317
	shield = 513
	flint = 318
	painting = 321
	sign = 323
	wooden_door = 324
	bucket = 325
	minecart = 328
	saddle = 329
	iron_door = 330
	redstone = 331
	snowball = 332
	boat = 333
	leather = 334
	kelp = 335
	brick = 336
	clay_ball = 337
	reeds = 338
	paper = 339
	book = 340
	slime_ball = 341
	chest_minecart = 342
	egg = 344
	compass = 345
	fishing_rod = 346
	clock = 347
	glowstone_dust = 348
	dye = 351
	bone = 352
	sugar = 353
	cake = 354
	bed = 355
	repeater = 356
	map = 358
	shears = 359
	ender_pearl = 368
	blaze_rod = 369
	ghast_tear = 370
	gold_nugget = 371
	potion = 373
	glass_bottle = 374
	fermented_spider_eye = 376
	blaze_powder = 377
	magma_cream = 378
	brewing_stand = 379
	cauldron = 380
	ender_eye = 381
	speckled_melon = 382
	spawn_egg = 383
	experience_bottle = 384
	fireball = 385
	writable_book = 386
	written_book = 387
	emerald = 388
	frame = 389
	flower_pot = 390
	emptyMap = 395
	skull = 397
	carrotOnAStick = 398
	netherStar = 399
	fireworks = 401
	fireworksCharge = 402
	enchanted_book = 403
	comparator = 404
	netherbrick = 405
	quartz = 406
	tnt_minecart = 407
	hopper_minecart = 408
	hopper = 410
	rabbit_foot = 414
	rabbit_hide = 415
	horsearmorleather = 416
	horsearmoriron = 417
	horsearmorgold = 418
	horsearmordiamond = 419
	record_13 = 500
	record_cat = 501
	record_blocks = 502
	record_chirp = 503
	record_far = 504
	record_mall = 505
	record_mellohi = 506
	record_stal = 507
	record_strad = 508
	record_ward = 509
	record_11 = 510
	record_wait = 511
	trident = 455
	lead = 420
	name_tag = 421
	prismarine_crystals = 422
	muttonRaw = 423
	muttonCooked = 424
	armor_stand = 425
	end_crystal = 426
	spruce_door = 427
	birch_door = 428
	jungle_door = 429
	acacia_door = 430
	dark_oak_door = 431
	chorus_fruit = 432
	chorus_fruit_popped = 433
	dragon_breath = 437
	splash_potion = 438
	lingering_potion = 441
	command_block_minecart = 443
	elytra = 444
	prismarine_shard = 409
	shulker_shell = 445
	banner = 446
	totem = 450
	iron_nugget = 452
	nautilus_shell = 465
	heart_of_the_sea = 467
	turtle_shell_piece = 468
	turtle_helmet = 469
	phantom_membrane = 470
	crossbow = 471
	spruce_sign = 472
	birch_sign = 473
	jungle_sign = 474
	acacia_sign = 475
	darkoak_sign = 476
	banner_pattern = 434
	campfire = 720
	suspicious_stew = 734
	debug_stick = 735
	honeycomb = 736
	honey_bottle = 737
	camera = 698
	compound = 499
	mod = 456
	ice_bomb = 453
	bleach = 451
	rapid_fertilizer = 449
	balloon = 448
	medicine = 447
	sparkler = 442
	glow_stick = 422
	lodestonecompass = 741
	netherite_ingot = 742
	netherite_sword = 743
	netherite_shovel = 744
	netherite_pickaxe = 745
	netherite_axe = 746
	netherite_hoe = 747
	netherite_helmet = 748
	netherite_chestplate = 749
	netherite_leggings = 750
	netherite_boots = 751
	netherite_scrap = 752
	crimson_sign = 753
	warped_sign = 754
	crimson_door = 755
	warped_door = 756
	warped_fungus_on_a_stick = 757
	chain = 758
	record_pigstep = 759
	nether_sprouts = 760
	soul_campfire = 801

class ItemUseMethodEnum(object):
	Unknown		= -1
	EquipArmor	= 0	# Equipping armor
	Eat			= 1	# Eating food
	Attack		= 2	# Attacking (anything?)
	Consume		= 3	# Consuming potion
	Throw		= 4	# Thrown item (snowball, potion)
	Shoot		= 5	# Bow+Arrow
	Place		= 6	# Place an item (e.g. Sign)
	FillBottle	= 7	# Attempted to fill an empty bottle
	FillBucket	= 8	# Attempted to fill an empty bucket
	PourBucket	= 9	# Pour contents of a filled bucket
	UseTool		= 10	# Use right-click function of a tool (flint&steel, hoe, shovel, etc)
	Interact	= 11
	Retrieved	= 12	# Currently only for reeling in the fishing rod

class KeyBoardType:
	KEY_GOBACK = 4

	KEY_BACKSPACE = 8
	KEY_TAB = 9
	KEY_RETURN = 13
	KEY_PAUSE = 19

	KEY_LSHIFT = 16
	KEY_CONTROL = 17
	KEY_MENU = 18
	KEY_CAPS_LOCK = 20
	KEY_ESCAPE = 27
	KEY_SPACE = 32
	KEY_PG_UP = 33
	KEY_PG_DOWN = 34
	KEY_END = 35
	KEY_HOME = 36

	KEY_LEFT = 37
	KEY_UP = 38
	KEY_RIGHT = 39
	KEY_DOWN = 40
	KEY_INSERT = 45
	KEY_DELETE = 46

	KEY_0 = 48
	KEY_1 = 49
	KEY_2 = 50
	KEY_3 = 51
	KEY_4 = 52
	KEY_5 = 53
	KEY_6 = 54
	KEY_7 = 55
	KEY_8 = 56
	KEY_9 = 57

	KEY_A = 65
	KEY_B = 66
	KEY_C = 67
	KEY_D = 68
	KEY_E = 69
	KEY_F = 70
	KEY_G = 71
	KEY_H = 72
	KEY_I = 73
	KEY_J = 74
	KEY_K = 75
	KEY_L = 76
	KEY_M = 77
	KEY_N = 78
	KEY_O = 79
	KEY_P = 80
	KEY_Q = 81
	KEY_R = 82
	KEY_S = 83
	KEY_T = 84
	KEY_U = 85
	KEY_V = 86
	KEY_W = 87
	KEY_X = 88
	KEY_Y = 89
	KEY_Z = 90

	KEY_NUMPAD0 = 96
	KEY_NUMPAD1 = 97
	KEY_NUMPAD2 = 98
	KEY_NUMPAD3 = 99
	KEY_NUMPAD4 = 100
	KEY_NUMPAD5 = 101
	KEY_NUMPAD6 = 102
	KEY_NUMPAD7 = 103
	KEY_NUMPAD8 = 104
	KEY_NUMPAD9 = 105
	KEY_MULTIPLY = 106
	KEY_ADD = 107

	KEY_SUBTRACT = 109
	KEY_DECIMAL = 110
	KEY_DIVIDE = 111
	KEY_F1 = 112
	KEY_F2 = 113
	KEY_F3 = 114
	KEY_F4 = 115
	KEY_F5 = 116
	KEY_F6 = 117
	KEY_F7 = 118
	KEY_F8 = 119
	KEY_F9 = 120
	KEY_F10 = 121
	KEY_F11 = 122
	KEY_F12 = 123
	KEY_F13 = 124

	KEY_NUM_LOCK = 144
	KEY_SCROLL = 145

	KEY_SEMICOLON = 186
	KEY_EQUALS = 187
	KEY_COMMA = 188
	KEY_MINUS = 189
	KEY_PERIOD = 190
	KEY_SLASH = 191
	KEY_GRAVE = 192

	KEY_LBRACKET = 219
	KEY_BACKSLASH = 220
	KEY_RBRACKET = 221
	KEY_APOSTRAPHE = 222

	KEY_ANDROID_MENU = 0xff

class OptionId(object):
	Undefined = ""
	AUTO_JUMP = "AUTO_JUMP" 			#自动跳跃
	HIDE_PAPERDOLL = "HIDE_PAPERDOLL"	#隐藏纸娃娃
	HIDE_HAND = "HIDE_HAND" 			#隐藏手
	SPLIT_CONTROLS = "SPLIT_CONTROLS" 	#准心瞄准

class PistonFacing(object):
	Down = 0
	Up = 1
	North = 2
	South = 3
	West = 4
	East = 5

class StructureFeatureType(object):
	Unknown = 0
	EndCity = 1
	Fortress = 2
	Mineshaft = 3
	Monument = 4
	Stronghold = 5
	Temple = 6
	Village = 7
	WoodlandMansion = 8
	Shipwreck = 9
	BuriedTreasure = 10
	Ruins = 11
	PillagerOutpost = 12
	RuinedPortal = 13
	Bastion = 14

class SysSoundType:
	ItemUseOn = 0
	Hit = 1
	Step = 2
	Fly = 3
	Jump = 4
	Break = 5
	Place = 6
	HeavyStep = 7
	Gallop = 8
	Fall = 9
	Ambient = 10
	AmbientBaby = 11
	AmbientInWater = 12
	Breathe = 13
	Death = 14
	DeathInWater = 15
	DeathToZombie = 16
	Hurt = 17
	HurtInWater = 18
	Mad = 19
	Boost = 20
	Bow = 21
	SquishBig = 22
	SquishSmall = 23
	FallBig = 24
	FallSmall = 25
	Splash = 26
	Fizz = 27
	Flap = 28
	Swim = 29
	Drink = 30
	Eat = 31
	Takeoff = 32
	Shake = 33
	Plop = 34
	Land = 35
	Saddle = 36
	Armor = 37
	ArmorPlace = 38
	AddChest = 39
	Throw = 40
	Attack = 41
	AttackNoDamage = 42
	AttackStrong = 43
	Warn = 44
	Shear = 45
	Milk = 46
	Thunder = 47
	Explode = 48
	Fire = 49
	Ignite = 50
	Fuse = 51
	Stare = 52
	Spawn = 53
	Shoot = 54
	BreakBlock = 55
	Launch = 56
	Blast = 57
	LargeBlast = 58
	Twinkle = 59
	Remedy = 60
	Unfect = 61
	LevelUp = 62
	BowHit = 63
	BulletHit = 64
	ExtinguishFire = 65
	ItemFizz = 66
	ChestOpen = 67
	ChestClosed = 68
	ShulkerBoxOpen = 69
	ShulkerBoxClosed = 70
	EnderChestOpen = 71
	EnderChestClosed = 72
	PowerOn = 73
	PowerOff = 74
	Attach = 75
	Detach = 76
	Deny = 77
	Tripod = 78
	Pop = 79
	DropSlot = 80
	Note = 81
	Thorns = 82
	PistonIn = 83
	PistonOut = 84
	Portal = 85
	Water = 86
	LavaPop = 87
	Lava = 88
	Burp = 89
	BucketFillWater = 90
	BucketFillLava = 91
	BucketEmptyWater = 92
	BucketEmptyLava = 93
	EquipChain = 94
	EquipDiamond = 95
	EquipGeneric = 96
	EquipGold = 97
	EquipIron = 98
	EquipLeather = 99
	EquipElytra = 100
	Record13 = 101
	RecordCat = 102
	RecordBlocks = 103
	RecordChirp = 104
	RecordFar = 105
	RecordMall = 106
	RecordMellohi = 107
	RecordStal = 108
	RecordStrad = 109
	RecordWard = 110
	Record11 = 111
	RecordWait = 112
	RecordNull = 113
	Flop = 114
	GuardianCurse = 115
	MobWarning = 116
	MobWarningBaby = 117
	Teleport = 118
	ShulkerOpen = 119
	ShulkerClose = 120
	Haggle = 121
	HaggleYes = 122
	HaggleNo = 123
	HaggleIdle = 124
	ChorusGrow = 125
	ChorusDeath = 126
	Glass = 127
	PotionBrewed = 128
	CastSpell = 129
	PrepareAttackSpell = 130
	PrepareSummon = 131
	PrepareWololo = 132
	Fang = 133
	Charge = 134
	TakePicture = 135
	PlaceLeashKnot = 136
	BreakLeashKnot = 137
	AmbientGrowl = 138
	AmbientWhine = 139
	AmbientPant = 140
	AmbientPurr = 141
	AmbientPurreow = 142
	DeathMinVolume = 143
	DeathMidVolume = 144
	ImitateBlaze = 145
	ImitateCaveSpider = 146
	ImitateCreeper = 147
	ImitateElderGuardian = 148
	ImitateEnderDragon = 149
	ImitateEnderman = 150
	ImitateEndermite = 151
	ImitateEvocationIllager = 152
	ImitateGhast = 153
	ImitateHusk = 154
	ImitateIllusionIllager = 155
	ImitateMagmaCube = 156
	ImitatePolarBear = 157
	ImitateShulker = 158
	ImitateSilverfish = 159
	ImitateSkeleton = 160
	ImitateSlime = 161
	ImitateSpider = 162
	ImitateStray = 163
	ImitateVex = 164
	ImitateVindicationIllager = 165
	ImitateWitch = 166
	ImitateWither = 167
	ImitateWitherSkeleton = 168
	ImitateWolf = 169
	ImitateZombie = 170
	ImitateZombiePigman = 171
	ImitateZombieVillager = 172
	EnderEyePlaced = 173
	EndPortalCreated = 174
	AnvilUse = 175
	BottleDragonBreath = 176
	PortalTravel = 177
	TridentHit = 178
	TridentReturn = 179
	TridentRiptide_1 = 180
	TridentRiptide_2 = 181
	TridentRiptide_3 = 182
	TridentThrow = 183
	TridentThunder = 184
	TridentHitGround = 185
	Default = 186
	FletchingTableUse = 187
	ElemConstructOpen = 188
	IceBombHit = 189
	BalloonPop = 190
	LTReactionIceBomb = 191
	LTReactionBleach = 192
	LTReactionElephantToothpaste = 193
	LTReactionElephantToothpaste2 = 194
	LTReactionGlowStick = 195
	LTReactionGlowStick2 = 196
	LTReactionLuminol = 197
	LTReactionSalt = 198
	LTReactionFertilizer = 199
	LTReactionFireball = 200
	LTReactionMagnesiumSalt = 201
	LTReactionMiscFire = 202
	LTReactionFire = 203
	LTReactionMiscExplosion = 204
	LTReactionMiscMystical = 205
	LTReactionMiscMystical2 = 206
	LTReactionProduct = 207
	SparklerUse = 208
	GlowStickUse = 209
	SparklerActive = 210
	ConvertToDrowned = 211
	BucketFillFish = 212
	BucketEmptyFish = 213
	BubbleColumnUpwards = 214
	BubbleColumnDownwards = 215
	BubblePop = 216
	BubbleUpInside = 217
	BubbleDownInside = 218
	HurtBaby = 219
	DeathBaby = 220
	StepBaby = 221
	SpawnBaby = 222
	Born = 223
	TurtleEggBreak = 224
	TurtleEggCrack = 225
	TurtleEggHatched = 226
	LayEgg = 227
	TurtleEggAttacked = 228
	BeaconActivate = 229
	BeaconAmbient = 230
	BeaconDeactivate = 231
	BeaconPower = 232
	ConduitActivate = 233
	ConduitAmbient = 234
	ConduitAttack = 235
	ConduitDeactivate = 236
	ConduitShort = 237
	Swoop = 238
	BambooSaplingPlace = 239
	PreSneeze = 240
	Sneeze = 241
	AmbientTame = 242
	Scared = 243
	ScaffoldingClimb = 244
	CrossbowLoadingStart = 245
	CrossbowLoadingMiddle = 246
	CrossbowLoadingEnd = 247
	CrossbowShoot = 248
	CrossbowQuickChargeStart = 249
	CrossbowQuickChargeMiddle = 250
	CrossbowQuickChargeEnd = 251
	AmbientAggressive = 252
	AmbientWorried = 253
	CantBreed = 254
	ShieldBlock = 255
	LecternBookPlace = 256
	GrindstoneUse = 257
	Bell = 258
	CampfireCrackle = 259
	Roar = 260
	Stun = 261
	SweetBerryBushHurt = 262
	SweetBerryBushPick = 263
	CartographyTableUse = 264
	StonecutterUse = 265
	ComposterEmpty = 266
	ComposterFill = 267
	ComposterFillLayer = 268
	ComposterReady = 269
	BarrelOpen = 270
	BarrelClose = 271
	RaidHorn = 272
	LoomUse = 273
	AmbientInRaid = 274
	UICartographyTableUse = 275
	UIStonecutterUse = 276
	UILoomUse = 277
	SmokerUse = 278
	BlastFurnaceUse = 279
	SmithingTableUse = 280
	Screech = 281
	Sleep = 282
	FurnaceUse = 283
	MooshroomConvert = 284
	MilkSuspiciously = 285
	Celebrate = 286
	JumpPrevent = 287
	AmbientPollinate = 288
	BeehiveDrip = 289
	BeehiveEnter = 290
	BeehiveExit = 291
	BeehiveWork = 292
	BeehiveShear = 293
	HoneybottleDrink = 294
	AmbientCave = 295
	Retreat = 296
	ConvertToZombified = 297
	Admire = 298
	StepLava = 299
	Tempt = 300
	Panic = 301
	Angry = 302
	AmbientWarpedForest = 303
	AmbientSoulsandValley = 304
	AmbientNetherWastes = 305
	AmbientBasaltDeltas = 306
	AmbientCrimsonForest = 307
	RespawnAnchorCharge = 308
	RespawnAnchorDeplete = 309
	RespawnAnchorSetSpawn = 310
	RespawnAnchorAmbient = 311
	SoulEscapeQuiet = 312
	SoulEscapeLoud = 313
	RecordPigstep = 314
	LinkCompassToLodestone = 315
	UseSmithingTable = 316
	Undefined = 317

class TimeEaseType(object):
	linear = "linear"
	spring = "spring"
	in_quad = "in_quad"
	out_quad = "out_quad"
	in_out_quad = "in_out_quad"
	in_cubic = "in_cubic"
	out_cubic = "out_cubic"
	in_out_cubic = "in_out_cubic"
	in_quart = "in_quart"
	out_quart = "out_quart"
	in_out_quart = "in_out_quart"
	in_quint = "in_quint"
	out_quint = "out_quint"
	in_out_quint = "in_out_quint"
	in_sine = "in_sine"
	out_sine = "out_sine"
	in_out_sine = "in_out_sine"
	in_expo = "in_expo"
	out_expo = "out_expo"
	in_out_expo = "in_out_expo"
	in_circ = "in_circ"
	out_circ = "out_circ"
	in_out_circ = "in_out_circ"
	in_bounce = "in_bounce"
	out_bounce = "out_bounce"
	in_out_bounce = "in_out_bounce"
	in_back = "in_back"
	out_back = "out_back"
	in_out_back = "in_out_back"
	in_elastic = "in_elastic"
	out_elastic = "out_elastic"
	in_out_elastic = "in_out_elastic"

class TouchEvent:
	TouchUp = 0
	TouchDown = 1
	TouchCancel = 3
	TouchMove = 4
	TouchMoveIn  = 5
	TouchMoveOut = 6

class UiBaseLayer(object):
	Desk = 0				# 主界面常驻
	DeskFloat = 15000		# 主界面浮动提示（浮动提示信息）
	PopUpLv1 = 25000		# 一级弹出界面
	PopUpLv2 = 45000		# 二级弹出界面
	PopUpModal = 60000		# 模态弹出界面（弹出提示）
	PopUpFloat = 75000		# 模态弹出之上的浮动提示（大喇叭）

class UseAnimation(object):
	Undefined = 'none'
	Eat = 'eat'
	Drink = 'drink'
	Block = 'block'
	Bow = 'bow'
	Camera = 'camera'
	Crossbow = 'crossbow'

class VirtualWorldObjectType(object):
	Model = 1
	Sfx = 2
	Textboard = 3
	Particle = 4

